# Copyright (C) 2020 Unitary Fund
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

# Quantum computer input/output.
from mitiq.typing import (
    SUPPORTED_PROGRAM_TYPES,
    QPROGRAM,
    MeasurementResult,
    QuantumResult,
    Bitstring,
    QuantumResult,
)

# Executors and observables.
from mitiq.executor import Executor
from mitiq.observable import PauliString, Observable

# Interface between Cirq circuits and supported frontends.
from mitiq import interface

# About and version.
from mitiq._about import about
from mitiq._version import __version__

# Error mitigation modules.
from mitiq import cdr, pec, rem, zne, ddd

# Calibration
from mitiq.calibration import (
    Calibrator,
    execute_with_mitigation,
    ZNESettings,
    Settings,
)

# Parallel interface for no error mitigation (for examples/benchmarking).
from mitiq import raw
